
    .cdecls C, list, "msp430.h" ; this allows us to use C headers

    .text                       ; locates code in 'text' section

	.global isqrt32

; Parameters
h_ls        .set		R12
h_ms        .set		R13

i           .set		R9
y_ls        .set		R10
y_ms        .set		R11
result_ls   .set		R12
result_ms   .set		R13
x_ls        .set		R14
x_ms        .set		R15

;uint32_t isqrt32(uint32_t h);
isqrt32:
;The answer is calculated as a 32 bit value, where the last
;16 bits are fractional.
    push.w  R9
    push.w  R10
    push.w  R11
    mov.w   #0,x_ls
    mov.w   #0,x_ms
    mov.w   #0,y_ls
    mov.w   #0,y_ms

    mov.w   #16,i
isqrt32_1
    setc
    rlc.w   x_ls
    rlc.w   x_ms
    sub.w   x_ls,y_ls
    subc.w  x_ms,y_ms
    jhs     isqrt32_2
    add.w   x_ls,y_ls
    addc.w  x_ms,y_ms
    sub.w   #2,x_ls
isqrt32_2
    inc     x_ls
    rla.w   h_ls
    rlc.w   h_ms
    rlc.w   y_ls
    rlc.w   y_ms
    rla.w   h_ls
    rlc.w   h_ms
    rlc.w   y_ls
    rlc.w   y_ms
    dec.w   i
    jne     isqrt32_1

    mov.w   #16,i
isqrt32_3
    setc
    rlc.w   x_ls
    rlc.w   x_ms
    sub.w   x_ls,y_ls
    subc.w  x_ms,y_ms
    jhs     isqrt32_4
    add.w   x_ls,y_ls
    addc.w  x_ms,y_ms
    sub.w   #2,x_ls
isqrt32_4
    inc     x_ls
    rla.w   y_ls
    rlc.w   y_ms
    rla.w   y_ls
    rlc.w   y_ms
    dec.w   i
    jne     isqrt32_3

    mov.w   x_ls,result_ls
    mov.w   x_ms,result_ms
    pop.w   R11
    pop.w   R10
    pop.w   R9

	.if $defined(__LARGE_DATA_MODEL__)
    retx
	.else
    ret
    .endif

    .end

