
    .cdecls C, list, "msp430.h" ; this allows us to use C headers

    .text                       ; locates code in 'text' section

	.global isqrt64

; Parameters
h_0      	.set		R12
h_1      	.set		R13
h_2      	.set		R14
h_3      	.set		R15

result_0 	.set		R12
result_1 	.set		R13
result_2 	.set		R14
result_3 	.set		R15

; Temporary variables
x_0         .set 		R8
x_1         .set 		R9
x_2         .set 		R10
x_3         .set 		R11
y_0         .set 		R4
y_1         .set 		R5
y_2         .set 		R6
y_3         .set 		R7

;uint64_t isqrt64(uint64_t h)
isqrt64:
    ;The answer is calculated as a 64 bit value, where the last
    ;32 bits are fractional.

    push.w  R4
    push.w  R5
    push.w  R6
    push.w  R7
    push.w  R8
    push.w  R9
    push.w  R10
    push.w  R11
 
    ; Use a variable on the stack as the loop counter
    mov.w   #32,R11
    push.w  R11

    mov.w   #0,x_0
    mov.w   #0,x_1
    mov.w   #0,x_2
    mov.w   #0,x_3
    mov.w   #0,y_0
    mov.w   #0,y_1
    mov.w   #0,y_2
    mov.w   #0,y_3
isqrt64_1
    setc
    rlc.w   x_0
    rlc.w   x_1
    rlc.w   x_2
    rlc.w   x_3
    sub.w   x_0,y_0
    subc.w  x_1,y_1
    subc.w  x_2,y_2
    subc.w  x_3,y_3
    jhs     isqrt64_2
    add.w   x_0,y_0
    addc.w  x_1,y_1
    addc.w  x_2,y_2
    addc.w  x_3,y_3
    sub.w   #2,x_0
isqrt64_2
    inc.w   x_0
    ;
    rla.w   h_0
    rlc.w   h_1
    rlc.w   h_2
    rlc.w   h_3
    rlc.w   y_0
    rlc.w   y_1
    rlc.w   y_2
    rlc.w   y_3
    ;
    rla.w   h_0
    rlc.w   h_1
    rlc.w   h_2
    rlc.w   h_3
    rlc.w   y_0
    rlc.w   y_1
    rlc.w   y_2
    rlc.w   y_3
    ;
    dec     0(sp)
    jne     isqrt64_1

    mov.w   #32,0(sp)
isqrt64_3
    setc
    rlc.w   x_0
    rlc.w   x_1
    rlc.w   x_2
    rlc.w   x_3
    sub.w   x_0,y_0
    subc.w  x_1,y_1
    subc.w  x_2,y_2
    subc.w  x_3,y_3
    jhs     isqrt64_4
    add.w   x_0,y_0
    addc.w  x_1,y_1
    addc.w  x_2,y_2
    addc.w  x_3,y_3
    sub.w   #2,x_0
isqrt64_4
    inc.w   x_0
    ;
    rla.w   y_0
    rlc.w   y_1
    rlc.w   y_2
    rlc.w   y_3
    ;
    rla.w   y_0
    rlc.w   y_1
    rlc.w   y_2
    rlc.w   y_3
    ;
    dec     0(sp)
    jne     isqrt64_3

    mov.w   x_0,result_0
    mov.w   x_1,result_1
    mov.w   x_2,result_2
    mov.w   x_3,result_3

	pop.w   R11
    pop.w   R11
    pop.w   R10
    pop.w   R9
    pop.w   R8
    pop.w   R7
    pop.w   R6
    pop.w   R5
    pop.w   R4

	.if $defined(__LARGE_DATA_MODEL__)
    retx
	.else
    ret
    .endif

    .end

