
    .cdecls C, list, "msp430.h" ; this allows us to use C headers

    .text                       ; locates code in 'text' section

	.global mac64_16_24

tmp		.set			R11
z		.set			R12
x		.set			R13
y_lo	.set			R14
y_hi	.set			R15

; Square and accumulate x into z
;void mac64_16_24(int64_t *z, int16_t x, int32_t y)
mac64_16_24:
    ; We need to do the multiply in 2 16x16=>32 chunks. It isn't easy to
    ; do this with signed multiplies, so we take care of the signs first
    ; and then do 2 unsigned multiplies
    .if $defined(__MSP430_HAS_MPY32__)
    mov.w   y_lo,&MPYS32L
    mov.b   y_hi,&MPYS32H_B
    mov.w   x,&OP2
    add.w   &RES0,0(z)
    addc.w  &RES1,2(z)
    addc.w  &RES2,4(z)
    addc.w  &RES3,6(z)
	.endif

	.if $defined(__MSP430_HAS_MPY__)
    push.w  tmp
    clr.w   tmp
    tst.w   y_hi
    jge     mac64_16_24_1
    ; The 24 bit y is negative
    xor.w   #1,tmp
    inv.w   y_hi
    inv.w   y_lo
    add.w   #1,y_lo
    addc.w  #0,y_hi
mac64_16_24_1
    tst.w   x
    jge     mac64_16_24_2
    ; The 16 bit x is negative
    xor.w   #1,tmp
    inv.w   x
    add.w   #1,x
mac64_16_24_2
    mov.w   x,&MPY
    tst.w   tmp
    jeq     mac64_16_24_3
    ; The answer to the real multiply will be negative, so subtract the unsigned one from the sum
    mov.w   y_hi,&OP2
    mov.w   #RESLO,tmp
    sub.w   @tmp+,2(z)
    subc.w  @tmp,4(z)
    subc.w  #0,6(z)
    ;
    mov.w   y_lo,&OP2
    sub.w   #2,tmp
    sub.w   @tmp+,0(z)
    subc.w  @tmp,2(z)
    subc.w  #0,4(z)
    subc.w  #0,6(z)
    ;
    pop.w   tmp
	.if $defined(__LARGE_DATA_MODEL__)
    retx
	.else
    ret
    .endif
mac64_16_24_3
    ; The answer to the real multiply will be positive, so add the unsigned one to the sum
    mov.w   y_hi,&OP2
    mov.w   #RESLO,tmp
    add.w   @tmp+,2(z)
    addc.w  @tmp,4(z)
    addc.w  #0,6(z)
    ;
    mov.w   y_lo,&OP2
    sub.w   #2,tmp
    add.w   @tmp+,0(z)
    addc.w  @tmp,2(z)
    addc.w  #0,4(z)
    addc.w  #0,6(z)
    ;
    pop.w   tmp
	.endif
    
	.if $defined(__LARGE_DATA_MODEL__)
    retx
	.else
    ret
    .endif

    .end













