
    .cdecls C, list, "msp430.h" ; this allows us to use C headers

    .text                       ; locates code in 'text' section

	.global sqac64_24

z		.set			R12
x_lo	.set			R13
x_hi	.set			R14
tmp		.set			R15

; Square and accumulate x into z
;void sqac64_24(int64_t *z, int32_t x);
sqac64_24:
	.if $defined(__MSP430_HAS_MPY32__)
    mov.w   #RES0,tmp
    mov.w   x_lo,&MPYS32L
    mov.b   x_hi,&MPYS32H_B
    mov.w   x_lo,&OP2L
    mov.b   x_hi,&OP2H_B
    add.w   @tmp+,0(z)
    addc.w  @tmp+,2(z)
    addc.w  @tmp+,4(z)
    addc.w  @tmp,6(z)
	.endif
	.if $defined(__MSP430_HAS_MPY__)
    ; We need to do the multiply in 4 chunks. It isn't easy to
    ; do this with signed multiplies, so we take care of the signs first
    ; and then do 2 unsigned multiplies
    tst.w   x_hi
    jge     sqac64_24_1
    ; The 24 bit x is negative
    inv.w   x_hi
    inv.w   x_lo
    add.w   #1,x_lo
    addc.w  #0,x_hi
sqac64_24_1
    mov.w   x_hi,&MPY
    mov.w   x_hi,&OP2
    mov.w   #RESLO,tmp
    add.w   @tmp+,4(z)
    addc.w  @tmp,6(z)
    ;
    mov.w   x_lo,&MPY
    mov.w   x_lo,&OP2
    sub.w   #2,tmp
    add.w   @tmp+,0(z)
    addc.w  @tmp,2(z)
    addc.w  #0,4(z)
    addc.w  #0,6(z)
    ;
    ; Note: It is this use of a shift which stops this routine being a full 32bit operation
    rla.w   x_hi
    mov.w   x_hi,&OP2
    sub.w   #2,tmp
    add.w   @tmp+,2(z)
    addc.w  @tmp,4(z)
    addc.w  #0,6(z)
	.endif

	.if $defined(__LARGE_DATA_MODEL__)
    retx
	.else
    ret
    .endif

    .end
